
frame .base -relief raised -bd 3

proc addGraphic { frame name index } {
	frame $frame.${name}${index}

	set command "setGraphic $name $index"

	scale $frame.${name}$index.s -length 100 -showvalue false -width 10 \
		-command $command -from 256 -to 0 -variable ${name}$index
	$frame.${name}$index.s set 128
	label $frame.${name}$index.l -text ${name}$index

	pack $frame.${name}$index.s $frame.${name}$index.l -side top
	pack $frame.${name}$index -side left -padx 2
}

proc addGraphics { frame name } {
	frame $frame -relief ridge -bd 3

	for {set index 0} \
		{$index != 8} \
		{set index [expr $index + 1]} {
		addGraphic $frame $name $index
	}

	pack $frame -side left -padx 10 -pady 5 -anchor n
}

proc addVuMeter { frame } {
	frame $frame -relief ridge -bd 3
	label $frame.top -text "Spectral Analysis" -font 6x9

	frame $frame.vu -relief ridge -bd 3 -bg black
	vumeter $frame.vu.vu -variable vuVar -height 65 -width 128 \
		-holdcount 2 -decay1 1 -decay2 1

	frame $frame.text
	label $frame.text.left -text Left -relief ridge -bd 3 -font 6x9
	label $frame.text.right -text Right -relief ridge -bd 3 -font 6x9

	pack $frame.top -side top -expand n -fill x
	pack $frame.vu -expand y -fill y
	pack $frame.vu.vu -side left -anchor w

	pack $frame.text -side bottom -expand n -fill x -anchor s
	pack $frame.text.left -side left -expand y -fill x
	pack $frame.text.right -side left -expand y -fill x
	pack $frame -side left -pady 5 -anchor n -expand y -fill y
}

proc addControl { frame name } {
	frame $frame -relief ridge -bd 3

	frame $frame.l

	set command "setGraphic left vol"
	scale $frame.l.s -length 100 -showvalue false -width 10 \
		-command $command -from 256 -to 0 
	$frame.l.s set 256
	label $frame.l.l -text lft
	pack $frame.l.s $frame.l.l -side top
	pack $frame.l -side left

	frame $frame.c
	set command "setGraphic main vol"
	scale $frame.c.s -length 100 -showvalue false -width 10 \
		-command $command -from 512 -to 0 
	$frame.c.s set 256
	label $frame.c.l -text volume
	pack $frame.c.s $frame.c.l -side top
	pack $frame.c -side left

	frame $frame.r
	set command "setGraphic right vol"
	scale $frame.r.s -length 100 -showvalue false -width 10 \
		-command $command -from 256 -to 0 
	$frame.r.s set 256
	label $frame.r.l -text rgt

	pack $frame.r.s $frame.r.l -side top
	pack $frame.r -side left

	pack $frame -side left -padx 5 -padx 10 -pady 5 -anchor n
}

proc buildPanel { frame } {
	addGraphics $frame.left l
	addVuMeter $frame.vu
	addGraphics $frame.right r
	addControl $frame.c c
}

buildPanel .base
pack .base

wm title . "Stereo Graphic Spectral Analyser"

after 300 checkDataPath

